#!/usr/bin/env python

"""
This test attempts to record the usage of 'C', 'D' or 'E' in the module code
since 'f' and 'g' might be used, but only 'f' is actually required. Although
only 'D' provides both attributes, classes 'C' and 'E' provide 'f'.

The local usage of 'g' in the 'local_usage' function is not currently
considered.
"""

class C:
    def f(self): # unused but retained
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

class E:
    def f(self): # unused but retained
        return 4

    def h(self): # unused
        return 5

def local_usage():
    return obj.g() # would indicate D usage

c = C()
d = D()
e = E()

obj = c
obj = d
                # obj: f, g; f
if obj.f():
    x = obj.g()
else:
    x = 2

result1_3 = x
result2_3 = local_usage()

# vim: tabstop=4 expandtab shiftwidth=4
